/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * ModelCase
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class ModelCase {
  @SerializedName("case_id")
  private String caseId = null;

  @SerializedName("status")
  private String status = null;

  @SerializedName("opened_at")
  private LocalDate openedAt = null;

  @SerializedName("updated_at")
  private LocalDate updatedAt = null;

  @SerializedName("beneficiaries")
  private Beneficiaries beneficiaries = null;

  @SerializedName("services")
  private Services services = null;

  public ModelCase caseId(String caseId) {
    this.caseId = caseId;
    return this;
  }

   /**
   * Case identifier
   * @return caseId
  **/
  @ApiModelProperty(example = "12345678912345-1234567891-123456789", value = "Case identifier")
  public String getCaseId() {
    return caseId;
  }

  public void setCaseId(String caseId) {
    this.caseId = caseId;
  }

  public ModelCase status(String status) {
    this.status = status;
    return this;
  }

   /**
   * Status of the case. Expected values (OPEN, ACTIVE, SETTLED, DENIED, CANCELLED, CLOSED)
   * @return status
  **/
  @ApiModelProperty(example = "ACTIVE", value = "Status of the case. Expected values (OPEN, ACTIVE, SETTLED, DENIED, CANCELLED, CLOSED)")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public ModelCase openedAt(LocalDate openedAt) {
    this.openedAt = openedAt;
    return this;
  }

   /**
   * Opening datetime of the case - UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mmZ)
   * @return openedAt
  **/
  @ApiModelProperty(example = "2017-01-17T00:00:00Z", value = "Opening datetime of the case - UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mmZ)")
  public LocalDate getOpenedAt() {
    return openedAt;
  }

  public void setOpenedAt(LocalDate openedAt) {
    this.openedAt = openedAt;
  }

  public ModelCase updatedAt(LocalDate updatedAt) {
    this.updatedAt = updatedAt;
    return this;
  }

   /**
   * Last update datetime of the case - UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mmZ)
   * @return updatedAt
  **/
  @ApiModelProperty(example = "2017-01-17T00:00:00Z", value = "Last update datetime of the case - UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mmZ)")
  public LocalDate getUpdatedAt() {
    return updatedAt;
  }

  public void setUpdatedAt(LocalDate updatedAt) {
    this.updatedAt = updatedAt;
  }

  public ModelCase beneficiaries(Beneficiaries beneficiaries) {
    this.beneficiaries = beneficiaries;
    return this;
  }

   /**
   * Get beneficiaries
   * @return beneficiaries
  **/
  @ApiModelProperty(value = "")
  public Beneficiaries getBeneficiaries() {
    return beneficiaries;
  }

  public void setBeneficiaries(Beneficiaries beneficiaries) {
    this.beneficiaries = beneficiaries;
  }

  public ModelCase services(Services services) {
    this.services = services;
    return this;
  }

   /**
   * Get services
   * @return services
  **/
  @ApiModelProperty(value = "")
  public Services getServices() {
    return services;
  }

  public void setServices(Services services) {
    this.services = services;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ModelCase _case = (ModelCase) o;
    return Objects.equals(this.caseId, _case.caseId) &&
        Objects.equals(this.status, _case.status) &&
        Objects.equals(this.openedAt, _case.openedAt) &&
        Objects.equals(this.updatedAt, _case.updatedAt) &&
        Objects.equals(this.beneficiaries, _case.beneficiaries) &&
        Objects.equals(this.services, _case.services);
  }

  @Override
  public int hashCode() {
    return Objects.hash(caseId, status, openedAt, updatedAt, beneficiaries, services);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ModelCase {\n");
    
    sb.append("    caseId: ").append(toIndentedString(caseId)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    openedAt: ").append(toIndentedString(openedAt)).append("\n");
    sb.append("    updatedAt: ").append(toIndentedString(updatedAt)).append("\n");
    sb.append("    beneficiaries: ").append(toIndentedString(beneficiaries)).append("\n");
    sb.append("    services: ").append(toIndentedString(services)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

